"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialogControllerBase = void 0;
const base_controller_1 = require("../base.controller");
const modal_service_1 = require("../../services/modal.service");
class DialogControllerBase extends base_controller_1.ControllerBase {
    constructor(scope, modalInstance, injector) {
        super(scope, injector);
        this.modalInstance = modalInstance;
        this.modalService = this.getService(modal_service_1.ModalService);
    }
    isActiveDialog() {
        return this.modalService.modals.last().key === this.modalInstance;
    }
    cancel() {
        this.modalInstance.close();
    }
    close(result = null) {
        this.modalInstance.resolve(result);
    }
}
exports.DialogControllerBase = DialogControllerBase;
//# sourceMappingURL=base.dialog.controller.js.map