"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Interceptor = void 0;
const registrable_1 = require("./registrable");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
function Interceptor(parameters) {
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters))
        throw new Error("Can not register an interceptor without an instance of IInterceptor.");
    return (constructor) => {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(constructor))
            throw new Error("Missing interceptor constructor.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            parameters.factory = constructor["factory"];
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            throw new Error("Missing interceptor factory.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.name))
            parameters.name = paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(constructor);
        constructor[registrable_1.registrableMetadataKey] = parameters;
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.module)) {
            parameters.module.registerInterceptor(constructor);
        }
    };
}
exports.Interceptor = Interceptor;
//# sourceMappingURL=interceptor.js.map