"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var AddClassDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddClassDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const base_directive_1 = require("./base.directive");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
const $ = require("jquery");
let AddClassDirective = AddClassDirective_1 = class AddClassDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        const options = {};
        this.tryGet(options, instanceAttributes, "element");
        this.tryGet(options, instanceAttributes, "addClass");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.element)) {
            const element = $(options.element);
            if (!element.hasClass(options.addClass)) {
                element.addClass(options.addClass);
            }
        }
    }
    static factory() {
        return new AddClassDirective_1();
    }
};
AddClassDirective = AddClassDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "addClass",
    })
], AddClassDirective);
exports.AddClassDirective = AddClassDirective;
//# sourceMappingURL=add-class.directive.js.map