/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
/// <reference types="angular-mocks" />
/// <reference types="jquery" />
import { DirectiveBase } from "./base.directive";
import { ITimeoutService, IScope, IAttributes, IController, ITranscludeFunction } from "angular";
export declare class AlertDirective extends DirectiveBase {
    private timeout;
    constructor(timeout: ITimeoutService);
    protected onInit(scope: IAlertScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    static factory(timeout: ITimeoutService): AlertDirective;
}
export interface IAlertScope extends IScope {
    alertType: string;
    timeout: string;
    close: Function;
}
