"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var BackgroundImageDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BackgroundImageDirective = void 0;
const tslib_1 = require("tslib");
const base_directive_1 = require("./base.directive");
const directive_1 = require("../decorators/directive");
const angular_service_1 = require("../services/angular.service");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
let BackgroundImageDirective = BackgroundImageDirective_1 = class BackgroundImageDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        scope.$watch(() => instanceAttributes["backgroundImage"], newValue => {
            if (paradigm_ui_web_shared_1.StringExtensions.isNullOrWhiteSpace(newValue))
                return;
            instanceElement.css("background-image", paradigm_ui_web_shared_1.StringExtensions.format("url({0})", newValue));
        });
    }
    static factory() {
        return new BackgroundImageDirective_1();
    }
};
BackgroundImageDirective = BackgroundImageDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "backgroundImage",
        dependencies: [angular_service_1.AngularServices.interpolate],
    })
], BackgroundImageDirective);
exports.BackgroundImageDirective = BackgroundImageDirective;
//# sourceMappingURL=background-image.directive.js.map