"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var DateTimePickerDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateTimePickerDirective = void 0;
const tslib_1 = require("tslib");
const base_directive_1 = require("./base.directive");
const directive_1 = require("../decorators/directive");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
const angular_service_1 = require("../services/angular.service");
let DateTimePickerDirective = DateTimePickerDirective_1 = class DateTimePickerDirective extends base_directive_1.DirectiveBase {
    constructor(filter) {
        super();
        this.filter = filter;
    }
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        var options = {};
        //////////////////////////////////////////////////////////////////
        // own properties
        //////////////////////////////////////////////////////////////////
        this.tryGet(options, instanceAttributes, "format");
        this.tryGet(options, instanceAttributes, "dayViewHeaderFormat");
        this.tryGetBoolean(options, instanceAttributes, "extraFormats");
        this.tryGetNumber(options, instanceAttributes, "stepping");
        this.tryGetDate(options, instanceAttributes, "minDate");
        this.tryGetDate(options, instanceAttributes, "maxDate");
        this.tryGetBoolean(options, instanceAttributes, "useCurrent");
        this.tryGetBoolean(options, instanceAttributes, "collapse");
        this.tryGet(options, instanceAttributes, "locale");
        this.tryGet(options, instanceAttributes, "viewMode");
        this.tryGetDate(options, instanceAttributes, "defaultDate");
        this.tryGetBoolean(options, instanceAttributes, "disabledDates");
        this.tryGetBoolean(options, instanceAttributes, "enabledDates");
        this.tryGetBoolean(options, instanceAttributes, "disabledHours");
        this.tryGetBoolean(options, instanceAttributes, "disabledTimeIntervals");
        this.tryGetBoolean(options, instanceAttributes, "useStrict");
        this.tryGetBoolean(options, instanceAttributes, "sideBySide");
        this.tryGetBoolean(options, instanceAttributes, "calendarWeeks");
        this.tryGet(options, instanceAttributes, "toolbarPlacement");
        this.tryGetBoolean(options, instanceAttributes, "showTodayButton");
        this.tryGetBoolean(options, instanceAttributes, "showClear");
        this.tryGetBoolean(options, instanceAttributes, "showClose");
        this.tryGetBoolean(options, instanceAttributes, "keepOpen");
        this.tryGetBoolean(options, instanceAttributes, "allowInputToggle");
        this.tryGetBoolean(options, instanceAttributes, "focusOnShow");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(instanceAttributes["maxDateToday"]))
            options.maxDate = new Date();
        instanceElement["datetimepicker"](options);
        instanceElement.on("dp.change", e => {
            if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) || options.format === "L")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"]) ? this.filter("date")(e["date"]._d, "MM/dd/yyyy") : null);
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) && options.format === "LT")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"]) ? this.filter("date")(e["date"]._d, "hh:mm") : null);
        });
        instanceElement.on("dp.show", () => {
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.viewMode)) {
                instanceElement.data("DateTimePicker").viewMode(options.viewMode);
            }
        });
    }
    static factory(filter) {
        return new DateTimePickerDirective_1(filter);
    }
};
DateTimePickerDirective = DateTimePickerDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "dateTimePicker",
        require: "ngModel",
        dependencies: [angular_service_1.AngularServices.filter],
    })
], DateTimePickerDirective);
exports.DateTimePickerDirective = DateTimePickerDirective;
//# sourceMappingURL=date-time-picker.directive.js.map