"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var FileDragAndDropDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileDragAndDropDirective = void 0;
const tslib_1 = require("tslib");
const base_directive_1 = require("./base.directive");
const directive_1 = require("../decorators/directive");
let FileDragAndDropDirective = FileDragAndDropDirective_1 = class FileDragAndDropDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        instanceElement[0].addEventListener("dragenter", () => instanceElement.addClass("file-drag-enter"), false);
        instanceElement[0].addEventListener("dragexit", () => instanceElement.removeClass("file-drag-enter"), false);
        instanceElement[0].addEventListener("dragend", () => instanceElement.removeClass("file-drag-enter"), false);
        instanceElement[0].addEventListener("dragleave", () => instanceElement.removeClass("file-drag-enter"), false);
        instanceElement[0].addEventListener("dragover", e => {
            instanceElement.addClass("file-drag-enter");
            e.dataTransfer.dropEffect = "copy";
            e.stopPropagation();
            e.preventDefault();
        }, false);
        instanceElement[0].addEventListener("drop", e => {
            scope.$eval(instanceAttributes["fileSelected"], { files: e.dataTransfer.files });
            instanceElement.removeClass("file-drag-enter");
            e.stopPropagation();
            e.preventDefault();
        }, false);
    }
    static factory() {
        return new FileDragAndDropDirective_1();
    }
};
FileDragAndDropDirective = FileDragAndDropDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "fileDragAndDrop",
    })
], FileDragAndDropDirective);
exports.FileDragAndDropDirective = FileDragAndDropDirective;
//# sourceMappingURL=file-drag-and-drop.directive.js.map