"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var FocusWhenDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FocusWhenDirective = void 0;
const tslib_1 = require("tslib");
const base_directive_1 = require("./base.directive");
const directive_1 = require("../decorators/directive");
const angular_service_1 = require("../services/angular.service");
let FocusWhenDirective = FocusWhenDirective_1 = class FocusWhenDirective extends base_directive_1.DirectiveBase {
    constructor(timeout) {
        super();
        this.timeout = timeout;
    }
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        var focusDelay = 100;
        if (instanceAttributes["focus-delay"])
            focusDelay = parseInt(instanceAttributes["focus-delay"], 10);
        scope.$watch(() => instanceAttributes["focusWhen"], () => {
            this.timeout(() => {
                try {
                    const model = scope.$eval(instanceAttributes["focusWhen"]);
                    if (model) {
                        instanceElement.focus();
                    }
                }
                catch (e) {
                    // ignore exceptions
                }
            }, focusDelay);
        });
    }
    static factory(timeout) {
        return new FocusWhenDirective_1(timeout);
    }
};
FocusWhenDirective = FocusWhenDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "focusWhen",
        dependencies: [angular_service_1.AngularServices.timeout],
    })
], FocusWhenDirective);
exports.FocusWhenDirective = FocusWhenDirective;
//# sourceMappingURL=focus-when.directive.js.map