"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var PreventEventIfDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreventEventIfDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const angular_service_1 = require("../services/angular.service");
const base_directive_1 = require("./base.directive");
let PreventEventIfDirective = PreventEventIfDirective_1 = class PreventEventIfDirective extends base_directive_1.DirectiveBase {
    constructor(timeout) {
        super();
        this.timeout = timeout;
    }
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        instanceElement.on(scope["preventEvent"], e => {
            if (scope["preventEventIf"]()) {
                event.preventDefault();
                e.stopPropagation();
            }
        });
    }
    static factory(timeout) {
        return new PreventEventIfDirective_1(timeout);
    }
};
PreventEventIfDirective = PreventEventIfDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "preventEventIf",
        bindings: {
            preventEventIf: "&",
            preventEvent: "@",
        },
        dependencies: [angular_service_1.AngularServices.timeout],
    })
], PreventEventIfDirective);
exports.PreventEventIfDirective = PreventEventIfDirective;
//# sourceMappingURL=prevent-event-if.directive.js.map