"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var RemoveClassDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemoveClassDirective = void 0;
const tslib_1 = require("tslib");
const base_directive_1 = require("./base.directive");
const directive_1 = require("../decorators/directive");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
const $ = require("jquery");
let RemoveClassDirective = RemoveClassDirective_1 = class RemoveClassDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        const options = {};
        this.tryGet(options, instanceAttributes, "element");
        this.tryGet(options, instanceAttributes, "removeClass");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.element)) {
            const element = $(options.element);
            if (element.hasClass(options.removeClass)) {
                element.removeClass(options.removeClass);
            }
        }
    }
    static factory() {
        return new RemoveClassDirective_1();
    }
};
RemoveClassDirective = RemoveClassDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "removeClass",
    })
], RemoveClassDirective);
exports.RemoveClassDirective = RemoveClassDirective;
//# sourceMappingURL=remove-class.directive.js.map