"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var ScrollToBottomDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollToBottomDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const base_directive_1 = require("./base.directive");
let ScrollToBottomDirective = ScrollToBottomDirective_1 = class ScrollToBottomDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        const options = {};
        this.tryGetBoolean(options, instanceAttributes, "onContentChange");
        this.tryGetBoolean(options, instanceAttributes, "onClick");
        if (options.onContentChange) {
            scope.$watch(() => instanceElement[0].innerHTML, () => instanceElement.scrollTop(instanceElement[0].scrollHeight));
        }
        if (options.onClick) {
            instanceElement.on("click", () => instanceElement.scrollTop(0));
        }
    }
    static factory() {
        return new ScrollToBottomDirective_1();
    }
};
ScrollToBottomDirective = ScrollToBottomDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "scrollToBottom",
    })
], ScrollToBottomDirective);
exports.ScrollToBottomDirective = ScrollToBottomDirective;
//# sourceMappingURL=scroll-to-bottom.directive.js.map