"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var ToggleClassOnClickDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToggleClassOnClickDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const base_directive_1 = require("./base.directive");
const $ = require("jquery");
let ToggleClassOnClickDirective = ToggleClassOnClickDirective_1 = class ToggleClassOnClickDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        var toggleElement = $(instanceAttributes["toggleElement"] || instanceElement);
        var toggleClass = instanceAttributes["toggleClass"];
        instanceElement.on("click touch", () => $(toggleElement).toggleClass(toggleClass));
    }
    static factory() {
        return new ToggleClassOnClickDirective_1();
    }
};
ToggleClassOnClickDirective = ToggleClassOnClickDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "toggleClassOnClick",
    })
], ToggleClassOnClickDirective);
exports.ToggleClassOnClickDirective = ToggleClassOnClickDirective;
//# sourceMappingURL=toggle-class-on-click.directive.js.map