"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var ToggleClassDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToggleClassDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const base_directive_1 = require("./base.directive");
const $ = require("jquery");
let ToggleClassDirective = ToggleClassDirective_1 = class ToggleClassDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        const options = {};
        this.tryGet(options, instanceAttributes, "element");
        this.tryGet(options, instanceAttributes, "toggleClass");
        const element = $(options.element) || instanceElement;
        if (!element.hasClass(options.toggleClass))
            element.addClass(options.toggleClass);
        else
            element.removeClass(options.toggleClass);
    }
    static factory() {
        return new ToggleClassDirective_1();
    }
};
ToggleClassDirective = ToggleClassDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "toggleClass",
    })
], ToggleClassDirective);
exports.ToggleClassDirective = ToggleClassDirective;
//# sourceMappingURL=toggle-class.directive.js.map