/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
/// <reference types="jquery" />
import { DirectiveBase } from "./base.directive";
import { IScope, IAttributes, ITranscludeFunction, IController } from "angular";
export declare class TooltipDirective extends DirectiveBase {
    protected onInit(scope: IScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    private normalTooltip;
    static factory(): TooltipDirective;
}
export interface ITooltipOptions {
    animation: "fade" | "grow" | "swing" | "slide" | "fall";
    animationDuration: number | number[];
    arrow: boolean;
    content: string | JQuery | any;
    contentAsHTML: boolean;
    contentCloning: boolean;
    debug: boolean;
    delay: number | number[];
    delayTouch: number | number[];
    distance: number | number[];
    IEmin: number;
    interactive: boolean;
    maxWidth: number;
    minIntersection: number;
    minWidth: number;
    multiple: boolean;
    plugins: string[];
    repositionOnScroll: boolean;
    restoration: "none" | "previous" | "current";
    selfDestruction: boolean;
    side: string | string[];
    timer: number;
    theme: string | string[];
    trackerInterval: number;
    trackOrigin: boolean;
    trackTooltip: boolean;
    trigger: "hover" | "click" | "custom";
    triggerClose: any;
    triggerOpen: any;
    updateAnimation: "fade" | "rotate" | "scale";
    viewportAware: boolean;
    zIndex: number;
}
