"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var TooltipDirective_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipDirective = void 0;
const tslib_1 = require("tslib");
const directive_1 = require("../decorators/directive");
const base_directive_1 = require("./base.directive");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
let TooltipDirective = TooltipDirective_1 = class TooltipDirective extends base_directive_1.DirectiveBase {
    onInit(scope, instanceElement, instanceAttributes, controller, transclude) {
        const options = this.getOptions(instanceAttributes, "tooltipsterOptions");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.content)) {
            this.normalTooltip(instanceElement, scope, instanceAttributes);
        }
        instanceElement.tooltipster(options);
    }
    normalTooltip(control, scope, instanceAttributes) {
        scope.$watch(() => instanceAttributes["title"], newValue => {
            if (paradigm_ui_web_shared_1.StringExtensions.isNullOrWhiteSpace(newValue))
                return;
            var tooltipsterData = control.data("tooltipster-ns");
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(tooltipsterData)) {
                control.removeAttr("title");
                control.tooltipster("content", newValue);
            }
        });
    }
    static factory() {
        return new TooltipDirective_1();
    }
};
TooltipDirective = TooltipDirective_1 = (0, tslib_1.__decorate)([
    (0, directive_1.Directive)({
        name: "tooltip",
        bindings: {
            tooltipOptions: "@",
            tooltipCose: "&",
            tooltipParameter: "=",
        },
    })
], TooltipDirective);
exports.TooltipDirective = TooltipDirective;
//# sourceMappingURL=tooltip.directive.js.map