/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
import { IHttpInterceptor, IRequestConfig, IPromise, IQService, IHttpResponse } from "angular";
export declare class InterceptorBase implements IHttpInterceptor {
    request?(config: IRequestConfig): IRequestConfig | IPromise<IRequestConfig>;
    requestError?(rejection: any): IRequestConfig | IPromise<IRequestConfig>;
    response?<T>(response: IHttpResponse<T>): IPromise<IHttpResponse<T>> | IHttpResponse<T>;
    responseError?<T>(rejection: any): IPromise<IHttpResponse<T>> | IHttpResponse<T>;
    protected q: IQService;
    constructor(q: IQService);
    onRequest(config: IRequestConfig): IRequestConfig | IPromise<IRequestConfig>;
    onResponse<T>(response: IHttpResponse<T>): IPromise<IHttpResponse<T>> | IHttpResponse<T>;
    onRequestError(rejection: any): IRequestConfig | IPromise<IRequestConfig>;
    onResponseError<T>(rejection: any): IPromise<IHttpResponse<T>> | IHttpResponse<T>;
}
