/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
/// <reference types="angular-translate" />
import { ControllerBase } from "../controllers/base.controller";
import { ITestPromiseService } from "./mock.service.spec";
import { IScope, translate } from "angular";
import { InjectorService } from "../services/injector.service";
import { LoggingService } from "../services/logging.service";
import { MessageBus } from "../services/message-bus.service";
import { AlertService } from "../services/alert.service";
import { StateService } from "@uirouter/angularjs";
import { ArrayList } from "@miracledevs/paradigm-ui-web-shared";
import { RegistrationToken } from "../services/message-bus.service";
export declare class MockController extends ControllerBase {
    readonly service: ITestPromiseService;
    numberResult: number;
    booleanResult: boolean;
    stringResult: string;
    dateResult: Date;
    objectResult: Object;
    arrayResult: Array<any>;
    rejectionReason: string;
    loading: boolean;
    errorShown: number;
    warningShown: number;
    messagesShown: number;
    constructor(scope: IScope, injector: InjectorService, testService: ITestPromiseService);
    getAlertService(): AlertService;
    getStateService(): StateService;
    getMessageBus(): MessageBus;
    getMessageBusTokens(): ArrayList<RegistrationToken>;
    getTranslator(): translate.ITranslateService;
    getLogger(): LoggingService;
    retrieveService<T>(name: string): T;
    testNumbers(): void;
    testBooleans(): void;
    testStrings(): void;
    testDates(): void;
    testObjects(): void;
    testArrays(): void;
    testRejection(): void;
    testLoading(): void;
    private isLoading;
}
