/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
/// <reference types="angular-mocks" />
import { ServiceBase } from "../services/base.service";
import { IPromise, IQService, ITimeoutService } from "angular";
import { LoggingService, LogType } from "../services/logging.service";
export declare class TestLoggingService extends LoggingService {
    private logWritten;
    constructor();
    log(message: string, type?: LogType, tag?: string): void;
    getLogWritten(type: LogType): number;
}
export interface ITestPromiseService {
    numberPromise(): IPromise<number>;
    booleanPromise(): IPromise<boolean>;
    stringPromise(): IPromise<string>;
    datePromise(): IPromise<Date>;
    objectPromise(): IPromise<Object>;
    arrayPromise(): IPromise<number[]>;
    rejectPromise(): IPromise<number>;
}
export declare class TestPromiseService extends ServiceBase implements ITestPromiseService {
    private readonly q;
    private readonly timeout;
    private readonly delay;
    readonly numberResult: number;
    readonly booleanResult: boolean;
    readonly stringResult: string;
    readonly dateResult: Date;
    readonly objectResult: Object;
    readonly arrayResult: Array<any>;
    readonly rejectionReason: string;
    constructor(q: ng.IQService, timeout: ITimeoutService);
    numberPromise(): ng.IPromise<number>;
    booleanPromise(): ng.IPromise<boolean>;
    stringPromise(): ng.IPromise<string>;
    datePromise(): ng.IPromise<Date>;
    objectPromise(): ng.IPromise<Object>;
    arrayPromise(): ng.IPromise<number[]>;
    rejectPromise(): ng.IPromise<number>;
    static factory(q: IQService, timeout: ITimeoutService): ITestPromiseService;
}
