"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var TestPromiseService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestPromiseService = exports.TestLoggingService = void 0;
const tslib_1 = require("tslib");
const base_service_1 = require("../services/base.service");
const angular_service_1 = require("../services/angular.service");
const service_1 = require("../decorators/service");
const logging_service_1 = require("../services/logging.service");
class TestLoggingService extends logging_service_1.LoggingService {
    constructor() {
        super();
        this.logWritten = [];
        this.logWritten[logging_service_1.LogType.Trace] = 0;
        this.logWritten[logging_service_1.LogType.Debug] = 0;
        this.logWritten[logging_service_1.LogType.Information] = 0;
        this.logWritten[logging_service_1.LogType.Warning] = 0;
        this.logWritten[logging_service_1.LogType.Error] = 0;
        this.logWritten[logging_service_1.LogType.Critical] = 0;
    }
    log(message, type = logging_service_1.LogType.Trace, tag = null) {
        // comment this line to disable test logs.
        // super.log(message, type, tag);
        this.logWritten[type]++;
    }
    getLogWritten(type) {
        return this.logWritten[type];
    }
}
exports.TestLoggingService = TestLoggingService;
let TestPromiseService = TestPromiseService_1 = class TestPromiseService extends base_service_1.ServiceBase {
    constructor(q, timeout) {
        super();
        this.q = q;
        this.timeout = timeout;
        this.delay = 500;
        this.numberResult = 1;
        this.booleanResult = true;
        this.stringResult = "hello world";
        this.dateResult = new Date(12, 12, 12);
        this.objectResult = { name: "custom object" };
        this.arrayResult = [1, 2, 3, 4];
        this.rejectionReason = "Testing promise rejection";
    }
    numberPromise() {
        return this.q.resolve(this.numberResult);
    }
    booleanPromise() {
        return this.q.resolve(this.booleanResult);
    }
    stringPromise() {
        return this.q.resolve(this.stringResult);
    }
    datePromise() {
        return this.q.resolve(this.dateResult);
    }
    objectPromise() {
        return this.q.resolve(this.objectResult);
    }
    arrayPromise() {
        return this.q.resolve(this.arrayResult);
    }
    rejectPromise() {
        return this.q.reject(this.rejectionReason);
    }
    static factory(q, timeout) {
        return new TestPromiseService_1(q, timeout);
    }
};
TestPromiseService = TestPromiseService_1 = (0, tslib_1.__decorate)([
    (0, service_1.Service)({
        name: "TestPromiseService",
        factory: TestPromiseService_1.factory,
        dependencies: [angular_service_1.AngularServices.q, angular_service_1.AngularServices.timeout],
    })
], TestPromiseService);
exports.TestPromiseService = TestPromiseService;
//# sourceMappingURL=mock.service.spec.js.map