"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var GeolocationService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeolocationService = void 0;
const tslib_1 = require("tslib");
const service_1 = require("../decorators/service");
const base_service_1 = require("./base.service");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
let GeolocationService = GeolocationService_1 = class GeolocationService extends base_service_1.ServiceBase {
    getPosition(callback, onError, options) {
        if (!this.isAvailable())
            return;
        this.getGeolocator().getCurrentPosition(callback, onError, options);
    }
    watchPosition(callback, onError, options) {
        if (!this.isAvailable())
            return -1;
        return this.getGeolocator().watchPosition(callback, onError, options);
    }
    clearWatch(watchId) {
        if (!this.isAvailable())
            return;
        this.getGeolocator().clearWatch(watchId);
    }
    isAvailable() {
        return !paradigm_ui_web_shared_1.ObjectExtensions.isNull(navigator.geolocation);
    }
    getGeolocator() {
        return navigator.geolocation;
    }
    static factory() {
        return new GeolocationService_1();
    }
};
GeolocationService = GeolocationService_1 = (0, tslib_1.__decorate)([
    (0, service_1.Service)({ name: "$pd-geolocationService" })
], GeolocationService);
exports.GeolocationService = GeolocationService;
//# sourceMappingURL=geolocation.service.js.map