"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var InjectorService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectorService = void 0;
const tslib_1 = require("tslib");
const angular_service_1 = require("./angular.service");
const base_service_1 = require("./base.service");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
const service_1 = require("../decorators/service");
const registrable_1 = require("../decorators/registrable");
let InjectorService = InjectorService_1 = class InjectorService extends base_service_1.ServiceBase {
    constructor(injector) {
        super();
        this.injector = injector;
    }
    get(service) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(service))
            return null;
        if (paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(service) === "String")
            return this.injector.get(service);
        return this.injector.get((0, registrable_1.getRegistrableName)(service) || paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(service));
    }
    static factory(injector) {
        return new InjectorService_1(injector);
    }
};
InjectorService = InjectorService_1 = (0, tslib_1.__decorate)([
    (0, service_1.Service)({ name: "$pd-injectorService", dependencies: [angular_service_1.AngularServices.injector] })
], InjectorService);
exports.InjectorService = InjectorService;
//# sourceMappingURL=injector.service.js.map