/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { Guid } from "@miracledevs/paradigm-ui-web-shared";
export declare class MessageBus extends ServiceBase {
    private handlers;
    constructor();
    count(): number;
    isRegistered<T>(messageType: new (...args: any[]) => T): boolean;
    handlerCount<T>(messageType: new (...args: any[]) => T): number;
    register<T>(messageType: {
        new (...args: any[]): T;
    }, handler: (x: T) => void): RegistrationToken;
    unregister(token: RegistrationToken): void;
    send<T>(message: T, token?: RegistrationToken): boolean;
    static factory(): MessageBus;
}
export declare class MessageBusHandler {
    private innerToken;
    private innerHandler;
    get token(): RegistrationToken;
    get handler(): Function;
    constructor(type: Function, handler: Function);
}
export declare class RegistrationToken {
    private innerType;
    private innerGuid;
    get type(): Function;
    get guid(): Guid;
    constructor(type: Function);
}
