"use strict";
/*!
 * Paradigm Framework - AngularJS Wrapper
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/Paradigm.Web.Shared/blob/master/LICENSE)
 */
var UrlService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.UrlService = void 0;
const tslib_1 = require("tslib");
const service_1 = require("../decorators/service");
const angular_service_1 = require("./angular.service");
const base_service_1 = require("./base.service");
const paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
let UrlService = UrlService_1 = class UrlService extends base_service_1.ServiceBase {
    constructor(sce) {
        super();
        this.sce = sce;
    }
    getParsedUrl(url) {
        if (!paradigm_ui_web_shared_1.StringExtensions.isString(url))
            return url;
        if (paradigm_ui_web_shared_1.StringExtensions.isNullOrEmpty(url))
            return url;
        if (url.indexOf("http://") < 0 && url.indexOf("https://") < 0)
            url = `http://${url}`;
        return this.sce.trustAsUrl(url);
    }
    static factory(sce) {
        return new UrlService_1(sce);
    }
};
UrlService = UrlService_1 = (0, tslib_1.__decorate)([
    (0, service_1.Service)({
        name: "$pd-urlService",
        dependencies: [angular_service_1.AngularServices.sce],
    })
], UrlService);
exports.UrlService = UrlService;
//# sourceMappingURL=url.service.js.map